diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
index cf32c907f..bacf15a44 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
@@ -4,7 +4,7 @@ import java.util.HashMap;
 import java.util.Map;
 
 import net.minecraft.client.render.EntityRenderDispatcher;
-import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java
index a1c191c8e..4eab6bba9 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java
@@ -7,8 +7,8 @@ import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.block.model.BlockModelPiston;
 import net.minecraft.client.render.block.model.BlockModelPistonHead;
-import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.piston.BlockPistonBase;
 import net.minecraft.core.block.piston.BlockPistonHead;
@@ -17,7 +17,7 @@ import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            TileEntitySpecialRenderer, Block, TileEntityPiston, TessellatorStandard,
+//            TileEntitySpecialRenderer, Block, TileEntityPiston, Tessellator,
 //            RenderHelper, RenderBlocks, BlockPistonBase, BlockPistonExtension, 
 //            World, TileEntity
 
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index c98681103..46e6da8f6 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -2,9 +2,8 @@ package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.tessalator.Tessellator;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.client.render.model.ModelSign;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.enums.EnumSignPicture;
@@ -122,7 +121,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
     {
         float uScale = 1 / 768F;
         float vScale = 1 / 384F;
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(x + 0, y + height * 2, 0, (float)(u + 0) * uScale, (float)(v + height) * vScale);
         tessellator.addVertexWithUV(x + width * 2, y + height * 2, 0, (float)(u + width) * uScale, (float)(v + height) * vScale);
diff --git a/src/main/java/net/minecraft/client/util/debug/DebugRender.java b/src/main/java/net/minecraft/client/util/debug/DebugRender.java
index a36d68ef1..2151a5486 100644
--- a/src/main/java/net/minecraft/client/util/debug/DebugRender.java
+++ b/src/main/java/net/minecraft/client/util/debug/DebugRender.java
@@ -6,7 +6,7 @@ import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.Display;
 
 import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.debug.Debug.Profiler;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -87,7 +87,7 @@ public class DebugRender {
 		glEnable(GL_BLEND);
 		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 		
-		TessellatorStandard tessellator = TessellatorStandard.instance;
+		Tessellator tessellator = Tessellator.instance;
 		
 		int x = w - frametimes.length;
 		int y = h;
@@ -149,7 +149,7 @@ public class DebugRender {
 		return avg;
 	}
 	
-	private static void drawFrameTimes(TessellatorStandard tessellator, int x, int y, long[] frametimes) {
+	private static void drawFrameTimes(Tessellator tessellator, int x, int y, long[] frametimes) {
 		int h1 = 16666666 / scale;
 		int h2 = 33333333 / scale;
 		
@@ -172,7 +172,7 @@ public class DebugRender {
 		tessellator.draw();
 	}
 	
-	private static void drawRectangle(TessellatorStandard tessellator, int x, int y, int w, int h) {
+	private static void drawRectangle(Tessellator tessellator, int x, int y, int w, int h) {
 		tessellator.addVertex(x, y, 0);
 		tessellator.addVertex(x+w, y, 0);
 		tessellator.addVertex(x+w, y+h, 0);
diff --git a/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java b/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
index e2b126ae8..f8122bf0b 100644
--- a/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
+++ b/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
@@ -98,11 +98,14 @@ public class BlockCropsPumpkin
 
         }
 
-        if(diagNeighbor || xNeighbor && zNeighbor) {
-            growthRate /= 2.0F;
-        }
-        if (world.getSeasonManager().getCurrentSeason() != null) {
-            growthRate *= world.getSeasonManager().getCurrentSeason().cropGrowthFactor;
+        boolean isFertilized = BlockFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
+        if (!isFertilized) {
+            if (world.getSeasonManager().getCurrentSeason() != null)
+            {
+                growthRate *= world.getSeasonManager().getCurrentSeason().cropGrowthFactor;
+            }
+        } else {
+            growthRate *= 1.5F;
         }
         return growthRate;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockCropsWheat.java b/src/main/java/net/minecraft/core/block/BlockCropsWheat.java
index 7d82dfdcf..1ac98285b 100644
--- a/src/main/java/net/minecraft/core/block/BlockCropsWheat.java
+++ b/src/main/java/net/minecraft/core/block/BlockCropsWheat.java
@@ -89,20 +89,36 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
                 }
                 growthRate += growthRateMod;
             }
-
         }
 
         if(diagNeighbor || xNeighbor && zNeighbor)
         {
             growthRate /= 2.0F;
         }
-        if (world.getSeasonManager().getCurrentSeason() != null)
-        {
-            growthRate *= world.getSeasonManager().getCurrentSeason().cropGrowthFactor;
+
+        boolean isFertilized = BlockFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
+        if (!isFertilized) {
+            if (world.getSeasonManager().getCurrentSeason() != null)
+            {
+                growthRate *= world.getSeasonManager().getCurrentSeason().cropGrowthFactor;
+            }
+        } else {
+            growthRate *= 1.5F;
         }
         return growthRate;
     }
 
+    @Override
+    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, int meta, EntityPlayer player, Item item) {
+        boolean isFertilized = BlockFarmland.isFertilized(world.getBlockMetadata(x, y - 1, z));
+        if (isFertilized) {
+            boolean shouldDefertilize = world.rand.nextInt(3) == 2;
+            if (shouldDefertilize) {
+                world.setBlockMetadata(x, y - 1, z, BlockFarmland.setFertilized(world.getBlockMetadata(x, y - 1, z), false));
+            }
+        }
+    }
+
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
     {
diff --git a/src/main/java/net/minecraft/core/block/BlockFarmland.java b/src/main/java/net/minecraft/core/block/BlockFarmland.java
index a65545e48..ccc8ef0fd 100644
--- a/src/main/java/net/minecraft/core/block/BlockFarmland.java
+++ b/src/main/java/net/minecraft/core/block/BlockFarmland.java
@@ -6,15 +6,19 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
-public class BlockFarmland extends Block
+public class BlockFarmland
+	extends Block
+	implements IBonemealable
 {
 	public BlockFarmland(String key, int id)
 	{
@@ -24,6 +28,23 @@ public class BlockFarmland extends Block
 		withLightBlock(255);
 	}
 
+	public static boolean isWet(int data) {
+		return (data & 0x0F) > 0;
+	}
+
+	public static int setWet(int data, int amount) {
+		return (amount & 0x0F) | (data & 0xF0);
+	}
+
+	public static boolean isFertilized(int data) {
+		return (data & 0x10) > 0;
+	}
+
+	public static int setFertilized(int data, boolean fertilized) {
+		int f = fertilized ? 0x10 : 0x00;
+		return (data & 0x0F) | f;
+	}
+
 	@Override
 	public AABB getCollisionBoundingBoxFromPool(final WorldSource world, final int x, final int y, final int z)
 	{
@@ -39,7 +60,7 @@ public class BlockFarmland extends Block
 			case PICK_BLOCK:
 				return new ItemStack[] { new ItemStack(this) };
 			default:
-				if(meta > 0){
+				if(isWet(world.getBlockMetadata(x, y, z))){
 					return new ItemStack[] { new ItemStack(Block.mud) };
 				} else {
 					return new ItemStack[] { new ItemStack(Block.dirt) };
@@ -47,14 +68,14 @@ public class BlockFarmland extends Block
 		}
 
 	}
-	private boolean isCropsNearby(final World world, final int i, final int j, final int k)
+	private boolean isCropsNearby(final World world, final int x, final int y, final int z)
 	{
-		final int l = 0;
-		for (int i1 = i - l; i1 <= i + l; i1++)
+		final int radius = 0;
+		for (int ix = x - radius; ix <= x + radius; ix++)
 		{
-			for (int j1 = k - l; j1 <= k + l; j1++)
+			for (int iz = z - radius; iz <= z + radius; iz++)
 			{
-				if (world.getBlockId(i1, j + 1, j1) == Block.cropsWheat.id)
+				if (world.getBlockId(ix, y + 1, iz) == Block.cropsWheat.id)
 				{
 					return true;
 				}
@@ -71,15 +92,15 @@ public class BlockFarmland extends Block
 		return false;
 	}
 
-	private boolean isWaterNearby(final World world, final int i, final int j, final int k)
+	private boolean isWaterNearby(final World world, final int x, final int y, final int z)
 	{
-		for (int l = i - 4; l <= i + 4; l++)
+		for (int ix = x - 4; ix <= x + 4; ix++)
 		{
-			for (int i1 = j; i1 <= j + 1; i1++)
+			for (int iy = y; iy <= y + 1; iy++)
 			{
-				for (int j1 = k - 4; j1 <= k + 4; j1++)
+				for (int iz = z - 4; iz <= z + 4; iz++)
 				{
-					if (Block.hasTag(world.getBlockId(l, i1, j1), BlockTags.IS_WATER))
+					if (Block.hasTag(world.getBlockId(ix, iy, iz), BlockTags.IS_WATER))
 					{
 						return true;
 					}
@@ -103,7 +124,7 @@ public class BlockFarmland extends Block
 				{
 					return;
 				}
-				if(world.getBlockMetadata(x, y, z) > 0)
+				if(isWet(world.getBlockMetadata(x, y, z)))
 					world.setBlockWithNotify(x, y, z, Block.mud.id);
 				else
 					world.setBlockWithNotify(x, y, z, Block.dirt.id);
@@ -119,7 +140,7 @@ public class BlockFarmland extends Block
 		final Material material = world.getBlockMaterial(x, y + 1, z);
 		if (material.isSolid())
 		{
-			if(world.getBlockMetadata(x, y, z) > 0)
+			if(isWet(world.getBlockMetadata(x, y, z)))
 				world.setBlockWithNotify(x, y, z, Block.mud.id);
 			else
 				world.setBlockWithNotify(x, y, z, Block.dirt.id);
@@ -134,27 +155,30 @@ public class BlockFarmland extends Block
 	}
 
 	@Override
-	public void updateTick(final World world, final int x, final int y, final int z, final Random rand)
-	{
-		if (rand.nextInt(5) == 0)
-		{
-			if (isWaterNearby(world, x, y, z) || world.canBlockBeRainedOn(x, y + 1, z))
-			{
-				world.setBlockMetadataWithNotify(x, y, z, 7);
-			}
-			else
-			{
-				final int l = world.getBlockMetadata(x, y, z);
-				if (l > 0)
-				{
-					world.setBlockMetadataWithNotify(x, y, z, l - 1);
-				}
-				else if (!isCropsNearby(world, x, y, z))
-				{
+	public void updateTick(final World world, final int x, final int y, final int z, final Random rand) {
+		if (rand.nextInt(5) == 0) {
+			int data = world.getBlockMetadata(x, y, z);
+			if (isWaterNearby(world, x, y, z) || world.canBlockBeRainedOn(x, y + 1, z)) {
+				world.setBlockMetadataWithNotify(x, y, z, data | 7);
+			} else {
+				if (isWet(data)) {
+					int newData = ((data & 0x0F) - 1) | (data & 0xF0);
+					world.setBlockMetadataWithNotify(x, y, z, newData);
+				} else if (!isCropsNearby(world, x, y, z)) {
 					world.setBlockWithNotify(x, y, z, Block.dirt.id);
 				}
 			}
 		}
 	}
 
+	@Override
+	public boolean onBonemealUsed(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+		int data = world.getBlockMetadata(blockX, blockY, blockZ);
+		if (!isFertilized(data)) {
+			world.setBlockMetadataWithNotify(blockX, blockY, blockZ, setFertilized(data, true));
+			return true;
+		}
+
+		return false;
+	}
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingOak.java b/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
index d0dc98c63..3a9c981d2 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
@@ -5,6 +5,7 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCaatinga;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.spooner.WorldFeatureSpoonerTreeRound;
 
 import java.util.Random;
 
diff --git a/src/main/java/net/minecraft/core/util/phys/Vec3d.java b/src/main/java/net/minecraft/core/util/phys/Vec3d.java
index fd4feab91..89488c6c9 100644
--- a/src/main/java/net/minecraft/core/util/phys/Vec3d.java
+++ b/src/main/java/net/minecraft/core/util/phys/Vec3d.java
@@ -11,9 +11,9 @@ import java.util.List;
 public class Vec3d
 {
 
-    public static Vec3d createVectorHelper(double d, double d1, double d2)
+    public static Vec3d createVectorHelper(double x, double y, double z)
     {
-        return new Vec3d(d, d1, d2);
+        return new Vec3d(x, y, z);
     }
 
     public static void deinitializePool()
@@ -33,26 +33,26 @@ public class Vec3d
         {
             vectorList.add(createVectorHelper(0.0D, 0.0D, 0.0D));
         }
-        return ((Vec3d)vectorList.get(nextVector++)).setComponents(x, y, z);
+        return vectorList.get(nextVector++).setComponents(x, y, z);
     }
 
-    private Vec3d(double d, double d1, double d2)
+    private Vec3d(double x, double y, double z)
     {
-        if(d == -0D)
+        if(x == -0D)
         {
-            d = 0.0D;
+            x = 0.0D;
         }
-        if(d1 == -0D)
+        if(y == -0D)
         {
-            d1 = 0.0D;
+            y = 0.0D;
         }
-        if(d2 == -0D)
+        if(z == -0D)
         {
-            d2 = 0.0D;
+            z = 0.0D;
         }
-        xCoord = d;
-        yCoord = d1;
-        zCoord = d2;
+        xCoord = x;
+        yCoord = y;
+        zCoord = z;
     }
 
     private Vec3d setComponents(double d, double d1, double d2)
@@ -179,7 +179,7 @@ public class Vec3d
     @Override
 	public String toString()
     {
-        return (new StringBuilder()).append("(").append(xCoord).append(", ").append(yCoord).append(", ").append(zCoord).append(")").toString();
+        return "(" + xCoord + ", " + yCoord + ", " + zCoord + ")";
     }
 
     public void rotateAroundX(float f)
@@ -206,7 +206,7 @@ public class Vec3d
         zCoord = d2;
     }
 
-    private static List vectorList = new ArrayList();
+    private static final List<Vec3d> vectorList = new ArrayList<>();
     private static int nextVector = 0;
     public double xCoord;
     public double yCoord;
diff --git a/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java b/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java
index 36fade506..a7e1ed1f4 100644
--- a/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java
+++ b/src/main/java/net/minecraft/core/world/biome/BiomeRainforest.java
@@ -5,6 +5,7 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancyRainforest;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeShrub;
 import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.spooner.WorldFeatureSpoonerTreeRound;
 
 import java.util.Random;
 
@@ -19,6 +20,10 @@ public class BiomeRainforest extends Biome
     @Override
 	public WorldFeature getRandomWorldGenForTrees(Random random)
     {
+        if (random.nextInt(1000) == 0) {
+            int treeHeight = 30 + random.nextInt(30);
+            return new WorldFeatureSpoonerTreeRound(treeHeight, Block.logOak.id, 0, Block.leavesOak.id, 0);
+        }
         if(random.nextInt(3) == 0)
         {
             if(random.nextInt(10) == 0)
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
index 1f2976c24..c4cc702be 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
@@ -23,75 +23,62 @@ public class WorldFeatureTree extends WorldFeature
     @Override
 	public boolean generate(World world, Random random, int x, int y, int z)
     {
-        int l = random.nextInt(3) + heightMod;
-        boolean flag = true;
-        if(y < 1 || y + l + 1 > world.getHeightBlocks())
-        {
+        int treeHeight = random.nextInt(3) + heightMod;
+        boolean canSpawn = true;
+        if(y < 1 || y + treeHeight + 1 > world.getHeightBlocks()) {
             return false;
         }
-        for(int i1 = y; i1 <= y + 1 + l; i1++)
-        {
-            byte byte0 = 1;
-            if(i1 == y)
-            {
-                byte0 = 0;
+        for (int iy = y; iy <= y + 1 + treeHeight; iy++) {
+            byte treeRadius = 1;
+            if (iy == y) {
+                treeRadius = 0;
             }
-            if(i1 >= (y + 1 + l) - 2)
-            {
-                byte0 = 2;
+            if (iy >= (y + 1 + treeHeight) - 2) {
+                treeRadius = 2;
             }
-            for(int i2 = x - byte0; i2 <= x + byte0 && flag; i2++)
-            {
-                for(int l2 = z - byte0; l2 <= z + byte0 && flag; l2++)
-                {
-                    if(i1 >= 0 && i1 < world.getHeightBlocks())
-                    {
-                        int j3 = world.getBlockId(i2, i1, l2);
-                        if(j3 != 0 && j3 != leavesID)
-                        {
-                            flag = false;
+            for(int ix = x - treeRadius; ix <= x + treeRadius && canSpawn; ix++) {
+                for(int iz = z - treeRadius; iz <= z + treeRadius && canSpawn; iz++) {
+                    if(iy >= 0 && iy < world.getHeightBlocks()) {
+                        int blockId = world.getBlockId(ix, iy, iz);
+                        if(blockId != 0 && blockId != leavesID) {
+                            canSpawn = false;
                         }
-                    } else
-                    {
-                        flag = false;
+                    } else {
+                        canSpawn = false;
                     }
                 }
-
             }
-
         }
 
-        if(!flag)
+        if(!canSpawn)
         {
             return false;
         }
         int idBelow = world.getBlockId(x, y - 1, z);
-        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - l - 1)
+        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - treeHeight - 1)
         {
             return false;
         }
         WorldFeatureTree.onTreeGrown(world, x, y, z);
-        for(int k1 = (y - 3) + l; k1 <= y + l; k1++)
+        for(int iy = (y - 3) + treeHeight; iy <= y + treeHeight; iy++)
         {
-            int j2 = k1 - (y + l);
+            int j2 = iy - (y + treeHeight);
             int i3 = 1 - j2 / 2;
-            for(int k3 = x - i3; k3 <= x + i3; k3++)
+            for(int ix = x - i3; ix <= x + i3; ix++)
             {
-                int l3 = k3 - x;
-                for(int i4 = z - i3; i4 <= z + i3; i4++)
+                int l3 = ix - x;
+                for(int iz = z - i3; iz <= z + i3; iz++)
                 {
-                    int j4 = i4 - z;
-                    if((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && !Block.solid[world.getBlockId(k3, k1, i4)])
+                    int j4 = iz - z;
+                    if((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && !Block.solid[world.getBlockId(ix, iy, iz)])
                     {
-                    	placeLeaves(world, k3, k1, i4, random);
+                    	placeLeaves(world, ix, iy, iz, random);
                     }
                 }
-
             }
-
         }
 
-        for(int l1 = 0; l1 < l; l1++)
+        for(int l1 = 0; l1 < treeHeight; l1++)
         {
             int id = world.getBlockId(x, y + l1, z);
             if(id == 0 || isLeaf(id))
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
index 9aef45d9b..b3fe1a229 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
@@ -39,13 +41,19 @@ public abstract class WorldFeatureSpoonerTree
         return iterations;
     }
 
-    protected static boolean assignValue(int x, int y, int z, int id, int meta, World world) {
+    protected boolean assignValue(int x, int y, int z, int id, int meta, World world) {
+        if (id == leavesId) {
+            if (!Block.solid[world.getBlockId(x, y, z)]) {
+                return world.setBlockAndMetadataWithNotify(x, y, z, id, meta);
+            }
+            return false;
+        }
         /* assign a block to the world */
         return world.setBlockAndMetadata(x, y, z, id, meta);
     }
 
-    protected final int[] pos;
-    protected final int height;
+    protected int[] pos = null;
+    protected int height;
     protected final int trunkId;
     protected final int trunkData;
     protected final int leavesId;
@@ -53,8 +61,7 @@ public abstract class WorldFeatureSpoonerTree
 
     protected Random random = null;
 
-    public WorldFeatureSpoonerTree(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
-        this.pos = new int[] { x, y, z };
+    public WorldFeatureSpoonerTree(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         this.height = height;
         this.trunkId = trunkId;
         this.trunkData = trunkData;
@@ -68,14 +75,53 @@ public abstract class WorldFeatureSpoonerTree
 
     protected void makeFoliage(World world) { }
 
+    private boolean canGenerateTree(World world)
+    {
+        int blockIdUnderneath = world.getBlockId(pos[0], pos[1] - 1, pos[2]);
+        if(!Block.hasTag(blockIdUnderneath, BlockTags.GROWS_TREES))
+        {
+            return false;
+        }
+        int interruptedTrunkHeight = -1;
+        int y = pos[1];
+        while (y < world.getHeightBlocks()) {
+            if (Block.solid[world.getBlockId(pos[0], y, pos[2])]) {
+                interruptedTrunkHeight = y - pos[1];
+                break;
+            }
+            y++;
+        }
+        if(interruptedTrunkHeight == -1)
+        {
+            return true;
+        }
+        if(interruptedTrunkHeight < 6)
+        {
+            return false;
+        }
+        else
+        {
+            height = interruptedTrunkHeight;
+            return true;
+        }
+    }
+
     @Override
     public boolean generate(World world, Random random, int x, int y, int z) {
         this.random = random;
+        this.pos = new int[] { x, y, z };
+
+        if (y < 1 || y > height + world.getHeightBlocks()) {
+            return false;
+        }
+        if (!canGenerateTree(world)) {
+            return false;
+        }
 
         prepare(world);
         makeFoliage(world);
         makeTrunk(world);
 
-        return false;
+        return true;
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java
index 143a4c596..2a5eaead6 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java
@@ -4,8 +4,8 @@ import net.minecraft.core.world.World;
 
 public class WorldFeatureSpoonerTreeBamboo
     extends WorldFeatureSpoonerTreeStick {
-    public WorldFeatureSpoonerTreeBamboo(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
-        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    public WorldFeatureSpoonerTreeBamboo(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(height, trunkId, trunkData, leavesId, leavesData);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java
index 1aaa6de03..a58b13990 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java
@@ -4,8 +4,8 @@ import net.minecraft.core.world.World;
 
 public class WorldFeatureSpoonerTreeCone
     extends WorldFeatureSpoonerTreeProcedural {
-    public WorldFeatureSpoonerTreeCone(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
-        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    public WorldFeatureSpoonerTreeCone(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(height, trunkId, trunkData, leavesId, leavesData);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java
index 493792162..6893ad3bd 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java
@@ -4,8 +4,8 @@ import net.minecraft.core.world.World;
 
 public class WorldFeatureSpoonerTreeMangrove
     extends WorldFeatureSpoonerTreeRound {
-    public WorldFeatureSpoonerTreeMangrove(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
-        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    public WorldFeatureSpoonerTreeMangrove(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(height, trunkId, trunkData, leavesId, leavesData);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java
index 958bc8c93..f97b0d722 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java
@@ -5,8 +5,8 @@ import net.minecraft.core.world.World;
 public class WorldFeatureSpoonerTreeNormal
     extends WorldFeatureSpoonerTreeStick {
 
-    public WorldFeatureSpoonerTreeNormal(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
-        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    public WorldFeatureSpoonerTreeNormal(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(height, trunkId, trunkData, leavesId, leavesData);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java
index 5c7525d17..66ce45ee3 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java
@@ -5,8 +5,8 @@ import net.minecraft.core.world.World;
 public class WorldFeatureSpoonerTreePalm
     extends WorldFeatureSpoonerTree {
 
-    public WorldFeatureSpoonerTreePalm(int x, int y, int z, int height, int trunkId, int trunkData, int leavesId, int leavesData) {
-        super(x, y, z, height, trunkId, trunkData, leavesId, leavesData);
+    public WorldFeatureSpoonerTreePalm(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
+        super(height, trunkId, trunkData, leavesId, leavesData);
     }
 
     @Override
